/*
 * Created on 10.09.2004
 *
 * Window - Preferences - Java - Code Style - Code Templates
 */
package de.lunqual.rzpro.ausgabe;

import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;

import javax.swing.table.AbstractTableModel;

import de.lunqual.rzpro.RzPro;
import de.lunqual.rzpro.items.buchung.SaldenItem;
import de.lunqual.rzpro.items.ergebnis.ErgebnisItem;
import de.lunqual.rzpro.items.ergebnis.ErgebnisListe;
import de.lunqual.rzpro.options.OptionFactory;

/**
 * @author labor
 *
 */
public class ErgebnislisteBestandDrucken extends ReportAusgabe {

    int 						key;
    public static final String			DEFAULT_ORIENTATION="landscape";
    ErgebnisListe			liste;
    SimpleDateFormat df;
    /**
     *
     */
    public ErgebnislisteBestandDrucken(RzPro r,Object reportData ,String optionKey,java.awt.Window w,ErgebnisListe liste) {
        super(r,reportData,optionKey,w);
        rz = r;
        df = new SimpleDateFormat("EEEE, dd. MM yyyy");
        this.optionKey=optionKey;
        key = ((Integer)reportData).intValue();
        this.liste=liste;
    }



    /** liefert ein TableModel
     * @param aKey Primärschlüssel einer Rezeptur/Verweis
     */
    @Override
	public void  createModel(){
        tableModel modell = null;
        Date now = new Date();
        SimpleDateFormat df = new SimpleDateFormat("EEEE d. MMMM yyyy");
        modell = new tableModel();
        if(modell != null) {
        	if(liste != null) {
        		rz.getDatabase().getBuchungen().getZugangAbgangListe(liste);
        		for(int i =	0;i < liste.size();i++) {
        			ErgebnisItem eli = liste.getItem(i);
                	final SaldenItem s = rz.getDatabase().getRezeptur().forceBestand(eli.getID());
                	String abgang = eli.getAbgang()!=null?rz.getLocale().getString("ergebnislistebestand.letzter_abgang").replaceAll("%s",df.format(eli.getAbgang())) :"";
                	String zugang = eli.getZugang()!=null?rz.getLocale().getString("ergebnislistebestand.letzter_zugang").replaceAll("%s",df.format(eli.getZugang())) :"";
        			modell.addItem(
        					rz.getDatabase().dbGetUser(),
        					now,
        					eli.getBezeichnung(),
        					eli.getArtikelnummer(),
        					 rz.getLocale().getString("ausgabe.bestand_detail_plain")
                				.replaceAll("%l",rz.getLocale().formatNumber(s.getLiter(), OptionFactory.NF_NORMAL)  )
                				.replaceAll("%k",rz.getLocale().formatNumber(s.getKg(), OptionFactory.NF_NORMAL)  )
                				.replaceAll("%a",rz.getLocale().formatNumber(s.getLa(), OptionFactory.NF_NORMAL)  ),
                			rz.getLocale().getString("ausgabe.rezeptur_temperatur") + ": "+
                			rz.getLocale().getString("ausgabe.rezeptur_temperatur_string") 
        							.replaceAll("%v",Integer.toString(eli.getTempVon()))
        							.replaceAll("%b",Integer.toString(eli.getTempBis()))
        							.replaceAll("%s",Integer.toString(eli.getTemperaturDurchschnitt()))
        							.replaceAll("%z", eli.isKonform()?(rz.getLocale().getString("ausgabe.rezeptur_konform")+ df.format(eli.getKonformDatum())):""),
        							abgang,
        							zugang
        					);
        		}
		        report = getReport();
		        report.setDataFactory(new org.jfree.report.TableDataFactory ("default", modell));
		        report.setQuery ("default");
        	}
        }
    }


    private class tableModel extends AbstractTableModel{

        private final String[] COLUMN_NAMES = {
                "user",
                "datum",
                "bezeichnung",
                "artikelnummer",
                "bestand",
                "temperatur",
                "letzterAbgang",
                "letzterZugang"
              };

              private final Class[] COLUMN_TYPE = {
            		  String.class,
            		  java.util.Date.class,
            		  String.class,
            		  String.class,
            		  String.class,
            		  String.class,
            		  String.class,
            		  String.class
              };

              private final ArrayList liste;

        tableModel() {
            liste = new ArrayList();
        }

        public void addItem (
                final String user,
                final Date datum,
                final String bezeichnung,
                final String artikelnummer,
                final String bestand,
                final String temperatur,
                final String letzterAbgang,
                final String letzterZugang
                )
        {
            	liste.add (new Object[] {user,datum,bezeichnung,artikelnummer,bestand,temperatur,letzterAbgang,letzterZugang});
        }

        @Override
		public Class getColumnClass (final int columnIndex)
        {
          return COLUMN_TYPE[columnIndex];
        }

        public int getColumnCount() {
            return COLUMN_TYPE.length;
        }

        @Override
		public String getColumnName (final int columnIndex)
        {
          return COLUMN_NAMES[columnIndex];
        }

        public int getRowCount ()
        {
          return liste.size();
        }

        public Object getValueAt (final int rowIndex, final int columnIndex)
        {
          final Object[] l = (Object[])liste.get (rowIndex);
          return l[columnIndex];
        }
    }
}

