/*
 *  Copyright (C) 2004 Karlheinz Klingbeil (lunqual)
 *
 *    This program is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this program; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */

package de.lunqual.rzpro.fenster.auswahlfenster;

//eigene Pakete
import java.awt.BorderLayout;
import java.awt.Component;
import java.awt.Dimension;
import java.awt.GridLayout;
import java.awt.event.KeyEvent;

import javax.swing.JButton;
import javax.swing.JLabel;
import javax.swing.JList;
import javax.swing.JMenu;
import javax.swing.JMenuBar;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JToolBar;
import javax.swing.ListCellRenderer;
import javax.swing.SwingConstants;

import de.lunqual.rzpro.RzPro;
import de.lunqual.rzpro.fenster.JRzFrame;
import de.lunqual.rzpro.fensterfactory.FensterFactory;
import de.lunqual.rzpro.items.action.AuswahlAction;
import de.lunqual.rzpro.items.ergebnis.DependencyItem;
import de.lunqual.rzpro.items.ergebnis.IDItem;
import de.lunqual.rzpro.items.message.MessageItem;
import de.lunqual.rzpro.options.OptionFactory;


/**
 *
 * @author  administrator
 */
public class DependencyFenster  extends JRzFrame{

    //GUI-Variablen
	private JMenuBar mb;
    	private JMenu mnuDatei;
    	private JMenu mnuExtras;
    	private JMenu mnuHilfe;
    private JPanel mainPanel;
    	private JPanel toolbarPanel;
    		private JToolBar tb1;
    	private JPanel contentPanel;
    		private JLabel lblTitel;
    		private JScrollPane scrListe;
    			private JList lstListe;
    		private JLabel lblRechnen;
    	private JPanel buttonPanel;
    		private JButton btClose;
    		private JButton btCalc;

    // ActionCodes KalkulationEingabe
    public static final int         ACTION_CLOSE_CODE = 1000;
    public static final String      ACTION_CLOSE_TEXT = "dependency.action_close";
    public static final int         ACTION_CALC_CODE = 1001;
    public static final String      ACTION_CALC_TEXT = "dependency.action_calc";


    IDItem			liste;

    static final String SHORTNAME_MASK = "****";

    /** Creates new form AdressAuswahl */

    public DependencyFenster(RzPro r, String name,Object extendedData) {
        super(r,name,extendedData);
        createActions();
        createGUIComponents();
        setGUIComponents();
        getMessage((MessageItem)extendedData);
    }

    @Override
	public void createGUIComponents() {
        mb = new JMenuBar();
		mnuDatei = new JMenu();
			mb.add(mnuDatei);
        mnuExtras = new JMenu();
        	mb.add(mnuExtras);
        mnuHilfe = new JMenu();
        	mb.add(mnuHilfe);
		setJMenuBar(mb);
		mainPanel = new JPanel(new BorderLayout());
			toolbarPanel = new JPanel(new BorderLayout());
				tb1 = new JToolBar();
				tb1.setFloatable(false);
				tb1.setRollover(true);
				toolbarPanel.add(tb1);
			mainPanel.add(toolbarPanel,BorderLayout.NORTH);
			contentPanel  = new JPanel(new BorderLayout());
	        	lblTitel = new JLabel();
	        		lblTitel.setHorizontalAlignment(SwingConstants.CENTER);
	        	contentPanel.add(lblTitel,BorderLayout.NORTH);
	        	scrListe = new JScrollPane();
	        		lstListe = new JList();
	        			lstListe.setCellRenderer(new ListRenderer(rz));
	        		scrListe.setViewportView(lstListe);
	        	contentPanel.add(scrListe,BorderLayout.CENTER);
	        	lblRechnen = new JLabel();
        		lblRechnen.setHorizontalAlignment(SwingConstants.CENTER);
        	contentPanel.add(lblRechnen,BorderLayout.SOUTH);
			buttonPanel=new JPanel(new GridLayout(1,3));
    			btClose=new JButton();
    				buttonPanel.add(btClose);
    			btCalc=new JButton();
    				buttonPanel.add(btCalc);
			mainPanel.add(toolbarPanel,BorderLayout.NORTH);
			mainPanel.add(contentPanel,BorderLayout.CENTER);
			mainPanel.add(buttonPanel,BorderLayout.SOUTH);

			getContentPane().setLayout(new BorderLayout());
			getContentPane().add(mainPanel,BorderLayout.CENTER);
    }
    @Override
	public void setGUIComponents() {
        setTitle(rz.getLocale().getString("dependency.titel"));
        mnuDatei.setText(rz.getLocale().getString("menu.datei"));
        mnuDatei.add(getAction(ACTION_CALC_CODE));
        mnuDatei.addSeparator();
        mnuDatei.add(getAction(ACTION_CLOSE_CODE));
        tb1.add(getAction(ACTION_CALC_CODE));
        tb1.addSeparator();
  	  	tb1.add(getAction(ACTION_CLOSE_CODE));
        btClose.setAction(getAction(ACTION_CLOSE_CODE));
        btCalc.setAction(getAction(ACTION_CALC_CODE));

        lblTitel.setText(rz.getLocale().getString("dependency.hilfe"));
        lblRechnen.setText("---");
         setResizable(true);
         rz.getFontFactory().setFrameFonts(this);
         this.setMinimumSize(new Dimension(300,300));
         this.setPreferredSize(new Dimension(300,300));
         pack();
         rz.getFensterFactory().setLocation(this,FensterFactory.POSITION_SIZE) ;
    }
    @Override
	public void getMessage(MessageItem msg) {
        switch(msg.getMsgCode()) {
    	case MessageItem.MSG_ACTIONPERFORMED:
            switch(msg.getCode()){
			case ACTION_CLOSE_CODE :okAction();break;
			case ACTION_CALC_CODE :calcAction();break;
			default :
                break;
           }
	      	break;
    	case MessageItem.MSG_DEPENDENCY_CALC:
    		liste = (IDItem)msg.getData();
            lblTitel.setText(rz.getLocale().getString("dependency.hilfe").replaceAll("%s",liste.getRezeptur()).replaceAll("%n",Integer.toString(liste.getListe().size())));
            lstListe.setListData(liste.getListe().toArray());
            break;
        default:
            rz.getLogFactory().logMessage(2, "dependencyFenster", "auswahlAction:" + msg.getMsgCode());
            break;
        }
    }

    @Override
	public void createActions(){
		actionList.put(String.valueOf(ACTION_CLOSE_CODE), new AuswahlAction(rz,this,ACTION_CLOSE_CODE,ACTION_CLOSE_TEXT,KeyEvent.VK_ESCAPE,	0));
		actionList.put(String.valueOf(ACTION_CALC_CODE), new AuswahlAction(rz,this,ACTION_CALC_CODE,ACTION_CALC_TEXT,KeyEvent.VK_ENTER,	0));
    }


    /**
     * berechnen
     */
    private void calcAction() {
    	if(liste.getListe().size() > 0) {
    		getAction(ACTION_CALC_CODE).setEnabled(false);
    		rz.setWaitCursor(this);
    		for(int i=0;i < liste.getListe().size();i++) {
    			if(liste.getListe().getItem(i).getStatus()==DependencyItem.STATUS_NONE) {
    				lblRechnen.setText(rz.getLocale().getString("dependency.rechnen").replaceAll("%s",liste.getListe().getItem(i).getName()));
    				rz.getDatabase().getRezeptur().calcSingle(liste.getListe().getItem(i).getId(),liste.getListe().getItem(i).getTyp());
    				liste.getListe().getItem(i).setStatus(DependencyItem.STATUS_OK);
    				lstListe.setListData(liste.getListe().toArray());
    			}
    		}
    		lblRechnen.setText("---");
    		rz.setFreeCursor(this);
    	}
    }
    /**
     * ok gedrückt... abspeichern oder ändern
     */
    private void okAction(){
    	closeWindow();
    }

    @Override
	public void closeWindow(){
        rz.getFensterFactory().getFensterListe().disposeFrame(this);
    }
    @Override
	public void openWindow(){
        if (!isVisible()) {
			setVisible(true);
		}
        toFront();
    }

    /*------------------------------------------------------------------------
     * ListenRenderer
     *
     *------------------------------------------------------------------------
     */
    private final class ListRenderer extends JLabel implements ListCellRenderer{
        RzPro   rz;
        public ListRenderer(RzPro r){
            rz = r;
            setOpaque(true);
        }

        public Component getListCellRendererComponent(JList list,Object value,int index, boolean isSelected,boolean cellHasFocus){
            final DependencyItem di = (DependencyItem)value;
            this.setFont(rz.getFontFactory().getListFont());
            setText(di.toString());
            if(index % 2 == 0){
                setBackground(rz.getOptionFactory().getColor(OptionFactory.COLOR_LIST_BACKGROUND_EVEN));
                setForeground(rz.getOptionFactory().getColor(OptionFactory.COLOR_LIST_FOREGROUND_NORMAL));
            }else {
                setBackground(rz.getOptionFactory().getColor(OptionFactory.COLOR_LIST_BACKGROUND_ODD));
                setForeground(rz.getOptionFactory().getColor(OptionFactory.COLOR_LIST_FOREGROUND_SELECTED));
            }
            return this;
        }
    }

}

