/*
 *  Copyright (C) 2004 Karlheinz Klingbeil (lunqual)
 *
 *    This program is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this program; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */

package de.lunqual.rzpro.fenster.tankfenster;

import java.awt.BorderLayout;
import java.awt.GridLayout;
import java.awt.event.InputEvent;
import java.awt.event.KeyEvent;

import javax.swing.BorderFactory;
import javax.swing.BoxLayout;
import javax.swing.ButtonGroup;
import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JLabel;
import javax.swing.JMenu;
import javax.swing.JMenuBar;
import javax.swing.JPanel;
import javax.swing.JRadioButton;
import javax.swing.JToolBar;
import javax.swing.SwingConstants;

import de.lunqual.rzpro.RzPro;
import de.lunqual.rzpro.fenster.JNumberField;
import de.lunqual.rzpro.fenster.JRzFrame;
import de.lunqual.rzpro.fenster.JSelectedTextField;
import de.lunqual.rzpro.fenster.dialoge.DialogControl;
import de.lunqual.rzpro.fensterfactory.FensterFactory;
import de.lunqual.rzpro.items.action.AuswahlAction;
import de.lunqual.rzpro.items.dialog.DialogItem;
import de.lunqual.rzpro.items.message.MessageItem;
import de.lunqual.rzpro.items.tank.ortItem;
import de.lunqual.rzpro.items.tank.tankItem;
import de.lunqual.rzpro.options.OptionFactory;


/**
 *
 * @author  administrator
 */
public class TankEingabeFenster extends JRzFrame {

    //GUI-Variablen
	private JMenuBar mb;
    	private JMenu mnuDatei;
    	private JMenu mnuExtras;
    	private JMenu mnuHilfe;
    private JPanel mainPanel;
    	private JPanel toolbarPanel;
    		private JToolBar tb1;
    	private JPanel contentPanel;
    		private JComboBox cmbOrt;
    		private JPanel eingabePanel;
    			private JPanel typPanel;
    				private ButtonGroup typButtons;
    					private JRadioButton btTypTank;
    					private JRadioButton btTypStellplatz;
    			private JPanel bezeichnungPanel;
    				private JLabel lblBezeichnung;
    				private JSelectedTextField txtBezeichnung;
    			private JPanel literPanel;
    				private JLabel lblLiter;
    				private JNumberField txtLiter;
        		private JPanel commentPanel;
    				private JLabel lblComment;
    				private JSelectedTextField txtComment;    				
    	private JPanel buttonPanel;
    		private JButton btOK;
    		private JButton btHilfe;
    		private JButton btCancel;

    // ActionCodes KalkulationEingabe
    public static final int         ACTION_OK_CODE = 1000;
    public static final String      ACTION_OK_TEXT = "tankeingabe.action_ok";
    public static final int         ACTION_ABBRECHEN_CODE = 1001;
    public static final String      ACTION_ABBRECHEN_TEXT = "tankeingabe.action_abbrechen";
    public static final int         ACTION_HILFE_CODE = 1002;
    public static final String      ACTION_HILFE_TEXT = "action_hilfe";
    public static final int         ACTION_HIDE_CODE = 1003;
    public static final String      ACTION_HIDE_TEXT = "action_hide";

    tankItem			ti;
    JRzFrame			origin;

    /** Creates new form AdressAuswahl */

    public TankEingabeFenster(RzPro r, String name,Object extendedData) {
        super(r,name,extendedData);
        createActions();
        createGUIComponents();
        setGUIComponents();
        getMessage((MessageItem)extendedData);
    }

    @Override
	public void createGUIComponents() {
        mb = new JMenuBar();
		mnuDatei = new JMenu();
			mb.add(mnuDatei);
        mnuExtras = new JMenu();
        	mb.add(mnuExtras);
        mnuHilfe = new JMenu();
        	mb.add(mnuHilfe);
		setJMenuBar(mb);
		mainPanel = new JPanel(new BorderLayout());
			toolbarPanel = new JPanel(new BorderLayout());
				tb1 = new JToolBar();
				tb1.setFloatable(false);
				tb1.setRollover(true);
				toolbarPanel.add(tb1);
			mainPanel.add(toolbarPanel,BorderLayout.NORTH);
			contentPanel  = new JPanel(new BorderLayout());
				cmbOrt=new JComboBox();
					rz.getDatabase().getTank().fillOrtCmb(cmbOrt);
				contentPanel.add(cmbOrt,BorderLayout.NORTH);
    			eingabePanel = new JPanel();
    				eingabePanel.setLayout(new BoxLayout(eingabePanel,BoxLayout.PAGE_AXIS));
    				typPanel = new JPanel(new BorderLayout());
    					typButtons = new ButtonGroup();
    						btTypTank = new JRadioButton();
    						btTypTank.addActionListener(new java.awt.event.ActionListener() {
    			                public void actionPerformed(java.awt.event.ActionEvent evt) {
    			                    if(txtLiter != null) {
    			                    	txtLiter.setEnabled(true);
    			                    	if(txtBezeichnung != null) {
    			                    		txtBezeichnung.requestFocus();
    			                    	}
    			                    }
    			                	}
    			            	});
    						typButtons.add(btTypTank);
    						btTypStellplatz = new JRadioButton();
    						btTypStellplatz.addActionListener(new java.awt.event.ActionListener() {
    			                public void actionPerformed(java.awt.event.ActionEvent evt) {
    			                    if(txtLiter != null) {
    			                    	txtLiter.setValue(0);
    			                    	txtLiter.setEnabled(false);
    			                    	if(txtBezeichnung != null) {
    			                    		txtBezeichnung.requestFocus();
    			                    	}
    			                    }
    			                	}
    			            	});
    						typButtons.add(btTypStellplatz);
    					typPanel.add(btTypTank, BorderLayout.NORTH);
    					typPanel.add(btTypStellplatz,BorderLayout.SOUTH);
    					typPanel.setBorder(BorderFactory.createEtchedBorder());
    				eingabePanel.add(typPanel);
    				bezeichnungPanel = new JPanel(new BorderLayout());
    					lblBezeichnung=new JLabel();
    						lblBezeichnung.setHorizontalAlignment(SwingConstants.TRAILING);
    					bezeichnungPanel.add(lblBezeichnung,BorderLayout.WEST);
    					txtBezeichnung = new JSelectedTextField();
    					bezeichnungPanel.add(txtBezeichnung,BorderLayout.CENTER);
    				eingabePanel.add(bezeichnungPanel);
    				
    				
    				literPanel = new JPanel(new BorderLayout());
					lblLiter=new JLabel();
						lblLiter.setHorizontalAlignment(SwingConstants.TRAILING);
					literPanel.add(lblLiter,BorderLayout.WEST);
					txtLiter = new JNumberField(rz.getLocale().getNumberFormat(OptionFactory.NF_ONE), 0.0, 0.0, Double.POSITIVE_INFINITY);
					literPanel.add(txtLiter,BorderLayout.CENTER);
					eingabePanel.add(literPanel);
    				
    				commentPanel = new JPanel(new BorderLayout());
					lblComment=new JLabel();
						lblComment.setHorizontalAlignment(SwingConstants.TRAILING);
					commentPanel.add(lblComment,BorderLayout.WEST);
					txtComment = new JSelectedTextField();
					commentPanel.add(txtComment,BorderLayout.CENTER);
					eingabePanel.add(commentPanel);
    			contentPanel.add(eingabePanel,BorderLayout.SOUTH);
			buttonPanel=new JPanel(new GridLayout(1,3));
    			btOK=new JButton();
    				buttonPanel.add(btOK);
    			btHilfe = new JButton();
    				buttonPanel.add(btHilfe);
    		    btCancel = new JButton();
    		    	buttonPanel.add(btCancel);
			mainPanel.add(toolbarPanel,BorderLayout.NORTH);
			mainPanel.add(contentPanel,BorderLayout.CENTER);
			mainPanel.add(buttonPanel,BorderLayout.SOUTH);

			getContentPane().setLayout(new BorderLayout());
			getContentPane().add(mainPanel,BorderLayout.CENTER);
    }
    @Override
	public void setGUIComponents() {
        setTitle(rz.getLocale().getString("tankeingabe.titel"));

        mnuDatei.setText(rz.getLocale().getString("menu.datei"));
        mnuExtras.setText(rz.getLocale().getString("menu.extras"));
        mnuHilfe.setText(rz.getLocale().getString("menu.hilfe"));
        mnuDatei.add(getAction(ACTION_OK_CODE));
        mnuDatei.addSeparator();
        mnuDatei.add(getAction(ACTION_ABBRECHEN_CODE));
        mnuExtras.add(getAction(ACTION_HIDE_CODE));
        mnuHilfe.add(getAction(ACTION_HILFE_CODE));

  	  	tb1.add(getAction(ACTION_OK_CODE));
  	  	tb1.add(getAction(ACTION_ABBRECHEN_CODE));
  	  	tb1.addSeparator();
  	  	tb1.add(getAction(ACTION_HIDE_CODE));
  	  	tb1.addSeparator();
  	  	tb1.add(getAction(ACTION_HILFE_CODE));

        btOK.setAction(getAction(ACTION_OK_CODE));
        btHilfe.setAction(getAction(ACTION_HILFE_CODE));
        btCancel.setAction(getAction(ACTION_ABBRECHEN_CODE));

        btOK.setAction(getAction(ACTION_OK_CODE));
        btCancel.setAction(getAction(ACTION_ABBRECHEN_CODE));
        btHilfe.setAction(getAction(ACTION_HILFE_CODE));

        lblBezeichnung.setText(rz.getLocale().getString("tankeingabe.label_nummer"));
        lblComment.setText(rz.getLocale().getString("tankeingabe.label_comment"));
        lblLiter.setText(rz.getLocale().getString("tankeingabe.label_liter"));
        btTypTank.setText(rz.getLocale().getString("tankeingabe.typ_tank"));
        btTypStellplatz.setText(rz.getLocale().getString("tankeingabe.typ_stellplatz"));
        
        setResizable(true);
        rz.getFontFactory().setFrameFonts(this);
        pack();
        rz.getFensterFactory().setLocation(this,FensterFactory.POSITION_SIZE) ;
    }
    @Override
	public void getMessage(MessageItem msg) {
        switch(msg.getMsgCode()) {
    	case MessageItem.MSG_ACTIONPERFORMED:
            switch(msg.getCode()){
            case ACTION_ABBRECHEN_CODE :cancelAction();break;
			case ACTION_OK_CODE :okAction();break;
            case ACTION_HILFE_CODE: hilfeAction();break;
            case ACTION_HIDE_CODE:hideAction();break;
            default :
                break;
           }
    		break;
         case MessageItem.MSG_SHOW_TANKEINGABE:
 			 origin = msg.getOrigin();
 			 ti = (tankItem)msg.getData();
 			 if(ti == null) {
 				ti = rz.getDatabase().getTank().getTank(0,msg.getCode()); 
 			 } 
 			 fromItem();
	      	break;

        default:
            break;
        }
    }

    @Override
	public void createActions(){
        actionList.put(String.valueOf(ACTION_HIDE_CODE),new AuswahlAction(rz,this,ACTION_HIDE_CODE,ACTION_HIDE_TEXT, KeyEvent.VK_F5 ,InputEvent.SHIFT_DOWN_MASK));
        actionList.put(String.valueOf(ACTION_HILFE_CODE),new AuswahlAction(rz,this,ACTION_HILFE_CODE,ACTION_HILFE_TEXT, KeyEvent.VK_F1 ,0));
		actionList.put(String.valueOf(ACTION_OK_CODE), new AuswahlAction(rz,this,ACTION_OK_CODE,ACTION_OK_TEXT,KeyEvent.VK_O,	InputEvent.CTRL_DOWN_MASK));
		actionList.put(String.valueOf(ACTION_ABBRECHEN_CODE), new AuswahlAction(rz,this, ACTION_ABBRECHEN_CODE,ACTION_ABBRECHEN_TEXT,KeyEvent.VK_ESCAPE, 0));

    }

    /**
     * ok gedrückt... abspeichern oder ändern
     */
    private void okAction(){
		final DialogItem di;
        if(toItem()) {
	        if(!ti.getNummer().trim().equals("")) {
	        	if(ti.getId()==0 && rz.getDatabase().getTank().tankExists(ti)) {
	        		di  = new DialogItem(
	    	                  DialogControl.HINWEIS_DIALOG,
	    	                  "",0.0,
	    	                  rz.getLocale().getString("tankeingabe.dialog_titel"),
	    	                  rz.getLocale().getString("tankeingabe.dialog_titel"),
	    	                  rz.getLocale().getString("tankeingabe.dialog_tank_exists").replaceAll("%s",ti.getNummer()),
	    	                  "warnung.png",
	    	                  rz.getLocale().getString("string_ok"),
	    	                  "",
	    	                  this
	    	          );
	    	          rz.getDialogFactory().getDialog(di);
	        	} else {
	        		rz.getDatabase().getTank().saveTank(ti);
	    			origin.getMessage(new MessageItem(MessageItem.MSG_TANKEINGABE_REPLY,ti.getId(),ti,this ));
	        		closeWindow();
	        	}
	        } else {
	        	di  = new DialogItem(
		                  DialogControl.HINWEIS_DIALOG,
		                  "",0.0,
		                  rz.getLocale().getString("tankeingabe.dialog_titel"),
		                  rz.getLocale().getString("tankeingabe.dialog_titel"),
		                  rz.getLocale().getString("tankeingabe.dialog_no_title"),
		                  "warnung.png",
		                  rz.getLocale().getString("string_ok"),
		                  "",
		                  this
		          );
		          rz.getDialogFactory().getDialog(di);
	        }
        }
     }

    /**
     * cancel
     */
    private void cancelAction(){
        closeWindow();
    }

    /**
     * Daten vom Item in die GUI übertragen
     *
     */
    private void fromItem(){
		btTypTank.setSelected(true);
    	ortItem oi = rz.getDatabase().getTank().getOrt( ti.getOrt());
    	if(oi != null) {
    		for(int i = 0;i < cmbOrt.getModel().getSize();i++) {
    			if(((ortItem)cmbOrt.getItemAt(i)).getId()==oi.getId()) {
    				cmbOrt.setSelectedIndex(i);
    				break;
    			}
    		}
    	}
    	txtBezeichnung.setText(ti.getNummer());
    	txtComment.setText(ti.getComment());
    	txtLiter.setValue(ti.getLiter());
    	if(ti.getId() == 0) {
    		btTypTank.setSelected(true);
    		txtLiter.setEnabled(true);
    	}else {
    		if( rz.isZero(ti.getLiter())) {
        		btTypStellplatz.setSelected(true);
        		txtLiter.setEnabled(false);
    		}
    	}
    }

    /**
     * GUI-Daten in das Item übertragen
     *
     */
    private boolean toItem(){
    	DialogItem di;
    	boolean ret = true;
    	if(btTypTank.isSelected()) {
    		if(rz.isZero(txtLiter.getValue())) {
    			ret = false;
    			di  = new DialogItem(
  	                  DialogControl.HINWEIS_DIALOG,
  	                  "",0.0,
  	                  rz.getLocale().getString("tankeingabe.dialog_titel"),
  	                  rz.getLocale().getString("tankeingabe.dialog_titel"),
  	                  rz.getLocale().getString("tankeingabe.dialog_no_value").replaceAll("%s",ti.getNummer()),
  	                  "warnung.png",
  	                  rz.getLocale().getString("string_ok"),
  	                  "",
  	                  this
  	          );
		      rz.getDialogFactory().getDialog(di);
    		} 
    	}
    	ti.setNummer(txtBezeichnung.getText().trim());
    	ti.setComment(txtComment.getText().trim());
    	ti.setLiter(txtLiter.getValue());
    	ti.setOrt(((ortItem)cmbOrt.getSelectedItem()).getId());
    	ti.setOrtBezeichnung(((ortItem)cmbOrt.getSelectedItem()).getBezeichnung());
    	ti.setOrtComment(((ortItem)cmbOrt.getSelectedItem()).getComment());
    	return ret;
    }

    @Override
	public void closeWindow(){
    	rz.getFensterFactory().getFensterListe().disposeFrame(this);
    }
    @Override
	public void openWindow(){
    	if(ti != null) {
    		if (!isVisible()) {
				setVisible(true);
			}
    		toFront();
    		txtBezeichnung.requestFocus();
    	} else {
    		closeWindow();
    	}
    }

	//hilfe
	private void hilfeAction() {
        rz.getFensterFactory().getFensterListe().createWindow(FensterFactory.FENSTER_HILFE,true,new MessageItem(MessageItem.MSG_HILFE,0,"tankeingabe.html",this));
	}

    private void hideAction() {
        rz.getFensterFactory().getFensterListe().sperren(this);
    }
}
